/* 
 * Free FFT and convolution (JavaScript)
 * 
 * Copyright (c) 2014 Project Nayuki
 * https://www.nayuki.io/page/free-small-fft-in-multiple-languages
 * 
 * (MIT License)
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * - The above copyright notice and this permission notice shall be included in
 *   all copies or substantial portions of the Software.
 * - The Software is provided "as is", without warranty of any kind, express or
 *   implied, including but not limited to the warranties of merchantability,
 *   fitness for a particular purpose and noninfringement. In no event shall the
 *   authors or copyright holders be liable for any claim, damages or other
 *   liability, whether in an action of contract, tort or otherwise, arising from,
 *   out of or in connection with the Software or the use or other dealings in the
 *   Software.
 */
/*
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
"use strict";function transform(r,n){if(r.length!=n.length)throw"Mismatched lengths";var t=r.length;0!=t&&(0==(t&t-1)?transformRadix2(r,n):transformBluestein(r,n))}function inverseTransform(r,n,t){if(transform(n,r),!t){var e=r.length;r.forEach(function(r,n,t){t[n]=t[n]/e}),n.forEach(function(r,n,t){t[n]=t[n]/e})}}function transformRadix2(r,n){function t(r,n){for(var t=0,e=0;e<n;e++)t=t<<1|1&r,r>>>=1;return t}if(r.length!=n.length)throw"Mismatched lengths";var e=r.length;if(1!=e){for(var a=-1,o=0;o<32;o++)1<<o==e&&(a=o);if(a==-1)throw"Length is not a power of 2";for(var f=new Array(e/2),h=new Array(e/2),o=0;o<e/2;o++)f[o]=Math.cos(2*Math.PI*o/e),h[o]=Math.sin(2*Math.PI*o/e);for(var o=0;o<e;o++){var l=t(o,a);if(l>o){var s=r[o];r[o]=r[l],r[l]=s,s=n[o],n[o]=n[l],n[l]=s}}for(var i=2;i<=e;i*=2)for(var v=i/2,g=e/i,o=0;o<e;o+=i)for(var l=o,c=0;l<o+v;l++,c+=g){var m=r[l+v]*f[c]+n[l+v]*h[c],w=-r[l+v]*h[c]+n[l+v]*f[c];r[l+v]=r[l]-m,n[l+v]=n[l]-w,r[l]+=m,n[l]+=w}}}function transformBluestein(r,n){if(r.length!=n.length)throw"Mismatched lengths";for(var t=r.length,e=1;e<2*t+1;)e*=2;for(var a=new Array(t),o=new Array(t),f=0;f<t;f++){var h=f*f%(2*t);a[f]=Math.cos(Math.PI*h/t),o[f]=Math.sin(Math.PI*h/t)}for(var l=new Array(e),s=new Array(e),f=0;f<t;f++)l[f]=r[f]*a[f]+n[f]*o[f],s[f]=-r[f]*o[f]+n[f]*a[f];for(var f=t;f<e;f++)l[f]=s[f]=0;var i=new Array(e),v=new Array(e);i[0]=a[0],v[0]=o[0];for(var f=1;f<t;f++)i[f]=i[e-f]=a[f],v[f]=v[e-f]=o[f];for(var f=t;f<=e-t;f++)i[f]=v[f]=0;var g=new Array(e),c=new Array(e);convolveComplex(l,s,i,v,g,c);for(var f=0;f<t;f++)r[f]=g[f]*a[f]+c[f]*o[f],n[f]=-g[f]*o[f]+c[f]*a[f]}function convolveReal(r,n,t){if(r.length!=n.length||r.length!=t.length)throw"Mismatched lengths";for(var e=new Array(r.length),a=0;a<e.length;a++)e[a]=0;convolveComplex(r,e,n,e.slice(),t,e.slice())}function convolveComplex(r,n,t,e,a,o){if(r.length!=n.length||r.length!=t.length||t.length!=e.length||r.length!=a.length||a.length!=o.length)throw"Mismatched lengths";var f=r.length;r=r.slice(),n=n.slice(),t=t.slice(),e=e.slice(),transform(r,n),transform(t,e);for(var h=0;h<f;h++){var l=r[h]*t[h]-n[h]*e[h];n[h]=n[h]*t[h]+r[h]*e[h],r[h]=l}inverseTransform(r,n,!0);for(var h=0;h<f;h++)a[h]=r[h]/f,o[h]=n[h]/f}var fft="undefined"==typeof exports?function(){}:exports;fft.transform=transform,fft.inverseTransform=inverseTransform;